diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/VertexArchetype.java b/sources/src/cz/zcu/kiv/offscreen/graph/VertexArchetype.java
new file mode 100644
index 0000000..d64c50a
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/VertexArchetype.java
@@ -0,0 +1,15 @@
+package cz.zcu.kiv.offscreen.graph;
+
+public class VertexArchetype {
+    public String name;
+    public String text;
+
+    VertexArchetype(String name, String text) {
+        this.name = name;
+        this.text = text;
+    }
+
+    public String getName() {
+        return name;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/VertexData.java b/sources/src/cz/zcu/kiv/offscreen/graph/VertexData.java
new file mode 100644
index 0000000..d03fee5
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/VertexData.java
@@ -0,0 +1,53 @@
+package cz.zcu.kiv.offscreen.graph;
+
+import java.util.*;
+
+public class VertexData {
+    public int id;
+    public String title;
+    public String text;
+    public int archetypeIndex;
+    public Map<Integer, Attribute> attributes = new HashMap<>();
+
+    public VertexData(int id, String title, String text, int archetypeIndex) {
+        this.id = id;
+        this.title = title;
+        this.text = text;
+        this.archetypeIndex = archetypeIndex;
+    }
+
+    public void addAttribute(int attrTypeIndex, Object value) {
+        Attribute attr = new Attribute(attrTypeIndex, value);
+        attributes.put(attrTypeIndex, attr);
+    }
+
+    public Attribute getAttribute(int attrTypeIndex) {
+        return attributes.get(attrTypeIndex);
+    }
+
+    @Override
+    public int hashCode() {
+        return id;
+    }
+
+    @Override
+    public boolean equals(Object edge) {
+        if (!(edge instanceof VertexData)) return false;
+        return id == ((VertexData) edge).id;
+    }
+
+    public void addAttributes(Map<Integer, Attribute> attributes) {
+        this.attributes.putAll(attributes);
+    }
+
+    public List<Attribute> getSortedAttributes() {
+        List<Attribute> list = new ArrayList<>();
+        ArrayList<Integer> indices = new ArrayList<>(attributes.keySet());
+        //indices.sort(Integer::compareTo);
+        Collections.sort(indices); // TODO check correct order
+        for (int i = 0; i < indices.size(); i++) {
+            list.add(attributes.get(indices.get(i)));
+        }
+        return list;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/VertexEfp.java b/sources/src/cz/zcu/kiv/offscreen/graph/VertexEfp.java
index a4b6c38..f17f0d5 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/VertexEfp.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/VertexEfp.java
@@ -8,9 +8,9 @@ import org.apache.log4j.Logger;
 import cz.zcu.kiv.offscreen.api.VertexInterface;
 
 /**
- * 
+ *
  * @author Jiri Loudil
- * 
+ *
  */
 public class VertexEfp implements VertexInterface {
 	private int id;
@@ -23,7 +23,7 @@ public class VertexEfp implements VertexInterface {
 	private Logger logger = Logger.getLogger(VertexEfp.class);
 
 	/**
-	 * 
+	 *
 	 * @param id
 	 * @param name
 	 * @param symbolicName
@@ -33,9 +33,9 @@ public class VertexEfp implements VertexInterface {
 		this.id = id;
 		this.name = name;
 		this.symbolicName = symbolicName;
-		
+
 		this.exportedPackages = new LinkedList<String>();
-        this.importedPackages = new LinkedList<String>();
+		this.importedPackages = new LinkedList<String>();
 
 		logger.trace("EXIT");
 	}
@@ -89,4 +89,24 @@ public class VertexEfp implements VertexInterface {
 		logger.trace("EXIT");
 	}
 
+	@Override
+	public int getArchetype() {
+		return 0;
+	}
+
+	@Override
+	public void setArchetype(int archetype) {
+
+	}
+
+	@Override
+	public void setAttributes(List<String[]> attributes) {
+
+	}
+
+	@Override
+	public List<String[]> getAttributes() {
+		return null;
+	}
+
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/VertexImpl.java b/sources/src/cz/zcu/kiv/offscreen/graph/VertexImpl.java
index a83257a..72b8750 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/VertexImpl.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/VertexImpl.java
@@ -3,6 +3,7 @@ package cz.zcu.kiv.offscreen.graph;
 import cz.zcu.kiv.offscreen.api.VertexInterface;
 import java.util.LinkedList;
 import java.util.List;
+
 import org.apache.log4j.Logger;
 
 /**
@@ -16,7 +17,12 @@ public class VertexImpl implements VertexInterface {
     private String symbolicName;
     private List<String> exportedPackages;
     private List<String> importedPackages;
+    private int archetype;
     private Logger logger = Logger.getLogger(VertexImpl.class);
+    /**
+     * list of attributes, the first value in each array is the attribute's name and the second value is its value
+     */
+    private List<String[]> attributes;
 //    private List<EdgeInterface> edges;
 
     public VertexImpl(int id, String name, String symbolicName) {
@@ -30,7 +36,7 @@ public class VertexImpl implements VertexInterface {
 //        this.edges = new ArrayList<EdgeInterface>();
     }
 
-//    public List<EdgeInterface> getEdges() {
+    //    public List<EdgeInterface> getEdges() {
 //        return edges;
 //    }
     @Override
@@ -49,21 +55,21 @@ public class VertexImpl implements VertexInterface {
 //    public void addEdge(EdgeInterface edge){
 //        this.edges.add(edge);
 //    }
-    
+
     @Override
     public List<String> getExportedPackages() {
         logger.trace("ENTRY");
         logger.trace("EXIT");
         return this.exportedPackages;
     }
-    
+
     @Override
     public List<String> getImportedPackages() {
         logger.trace("ENTRY");
         logger.trace("EXIT");
         return this.importedPackages;
     }
-    
+
     @Override
     public void setExportedPackages(List<String> exportedPackages) {
         logger.trace("ENTRY");
@@ -78,6 +84,26 @@ public class VertexImpl implements VertexInterface {
         logger.trace("EXIT");
     }
 
+    @Override
+    public int getArchetype() {
+        return archetype;
+    }
+
+    @Override
+    public void setArchetype(int archetype) {
+        this.archetype = archetype;
+    }
+
+    @Override
+    public void setAttributes(List<String[]> attributes) {
+        this.attributes = attributes;
+    }
+
+    @Override
+    public List<String[]> getAttributes() {
+        return attributes;
+    }
+
     @Override
     public String getSymbolicName() {
         return this.symbolicName;
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/creator/EfpGraphTransfomer.java b/sources/src/cz/zcu/kiv/offscreen/graph/creator/EfpGraphTransfomer.java
index 62f06a2..fb8f0eb 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/creator/EfpGraphTransfomer.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/creator/EfpGraphTransfomer.java
@@ -1,397 +1,397 @@
-package cz.zcu.kiv.offscreen.graph.creator;
-
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-
-import org.apache.log4j.Logger;
-
-import cz.zcu.kiv.efps.comparator.result.EfpEvalResult.MatchingResult;
-import cz.zcu.kiv.offscreen.api.EdgeInterface;
-import cz.zcu.kiv.offscreen.api.GraphInterface;
-import cz.zcu.kiv.offscreen.api.VertexInterface;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexData;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexDataEfp;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexDataFeature;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
-import cz.zcu.kiv.offscreen.graph.EdgeEfp;
-import cz.zcu.kiv.offscreen.graph.GraphImpl;
-import cz.zcu.kiv.offscreen.graph.VertexEfp;
-import cz.zcu.kiv.offscreen.graph.efp.EfpComparison;
-import cz.zcu.kiv.offscreen.graph.efp.EfpFeature;
-
-/**
- * 
- * Transforms data obtained in form of Map<String, CocaexData> to
- * cz.zcu.kiv.offscreen.api.GraphInterface.
- * 
- * @author Jiri Loudil
- * 
- */
-public class EfpGraphTransfomer {
-	
-	private final String DELIMITER = ";";
-
-	/**
-	 * Output data format.
-	 */
-	private GraphInterface graph = null;
-
-	/**
-	 * Input data format.
-	 */
-	private Map<String, CocaexData> resultData = null;
-
-	private Map<String, String> resultFeaturesMapping = null;
-
-	private Map<String, String> resultEfpsMapping = null;
-
-	/**
-	 * Already used vertices.
-	 */
-	private Map<String, VertexInterface> vertexMap;
-
-	/**
-	 * Already used features.
-	 */
-	private Map<String, EfpFeature> featureMap;
-
-	/**
-	 * Logging.
-	 */
-	private Logger logger = Logger.getLogger(EfpGraphTransfomer.class);
-
-	/**
-	 * New transformer from input data.
-	 * 
-	 * @param efpportalResultsWrapper
-	 *            Input data in from of EfpPortal app.
-	 */
-	public EfpGraphTransfomer(CocaexWrapper efpportalResultsWrapper) {
-		logger.trace("ENTRY");
-		this.graph = new GraphImpl();
-
-		this.resultData = efpportalResultsWrapper.getData();
-		this.resultEfpsMapping = efpportalResultsWrapper.getEfpMappings();
-		this.resultFeaturesMapping = efpportalResultsWrapper
-				.getFeatureMappings();
-
-		this.vertexMap = new HashMap<String, VertexInterface>();
-		this.featureMap = new HashMap<String, EfpFeature>();
-
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * Generates the graph with vertices and edges.
-	 * 
-	 * @return graph
-	 */
-	public GraphInterface transform() {
-		logger.trace("ENTRY");
-		this.generateVertices();
-		this.generateEdges();
-
-		// set proper feature and efp names
-		this.setNamesInsteadOfNumbers();
-		logger.trace("EXIT");
-
-		return this.graph;
-	}
-
-	/**
-	 * Substitute ID for the proper name string.
-	 */
-	private void setNamesInsteadOfNumbers() {
-		logger.trace("ENTRY");
-
-		List<EdgeInterface> edges = graph.getEdges();
-
-		for (EdgeInterface edgeInterface : edges) {
-			ArrayList<EfpFeature> features = ((EdgeEfp) edgeInterface)
-					.getFeatures();
-
-			for (EfpFeature efpFeature : features) {
-				// substitute ID for the true name from the feature mapping
-				String tmpFeatureName = resultFeaturesMapping.get(efpFeature.getName());
-
-				efpFeature.setName(tmpFeatureName.split(DELIMITER)[1]);
-
-				ArrayList<EfpComparison> efps = efpFeature.getEfps();
-
-				for (EfpComparison efpComparison : efps) {
-					// substitute ID for the true name from the efps mapping
-					efpComparison.setEfpName(resultEfpsMapping
-							.get(efpComparison.getEfpName()));
-				}
-			}
-		}
-
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * Generate vertices for this graph.
-	 */
-	private void generateVertices() {
-		logger.trace("ENTRY");
-
-		int id = 0;
-		VertexEfp vertex;
-
-		for (Map.Entry<String, CocaexData> tmpData : resultData.entrySet()) {
-			id++;
-
-			vertex = new VertexEfp(id, tmpData.getKey(), tmpData.getKey());
-
-			this.graph.addVertex(tmpData.getKey(), vertex);
-			this.vertexMap.put(tmpData.getKey(), vertex);
-		}
-
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * Generate edges for this graph.
-	 */
-	private void generateEdges() {
-		logger.trace("ENTRY");
-
-		int id = 0;
-		String from, to;
-		CocaexData currentEvaluatedVertexData;
-
-		for (Map.Entry<String, VertexInterface> currentVertex : vertexMap
-				.entrySet()) {
-			currentEvaluatedVertexData = resultData.get(currentVertex.getKey());
-
-			to = currentVertex.getKey();
-
-			// all required features FROM
-			for (Map.Entry<String, CocaexDataFeature> tmpRequired : currentEvaluatedVertexData
-					.getRequiredFeatures().entrySet()) {
-
-				String requiredFeatureName = this.resultFeaturesMapping
-						.get(tmpRequired.getKey());
-
-				// get feature name, its first part is component name
-				String[] requiredSplits = requiredFeatureName.split(DELIMITER);
-
-				// not-connected ones are left over
-				if (!requiredSplits[0].isEmpty()) {
-
-					// vertex from == vertex to -> we dont want that...
-					if (requiredSplits[0].equals(currentVertex.getKey())) {
-						continue;
-					}
-
-					// find corresponding feature on the TO vertex
-					CocaexData otherVertexData = resultData
-							.get(requiredSplits[0]);
-					CocaexDataFeature otherVertexFeature = null;
-
-					// go through all features of the TO  
-					for (Map.Entry<String, CocaexDataFeature> tmpProvided : otherVertexData
-							.getProvidedFeatures().entrySet()) {
-						String providedFeatureName = this.resultFeaturesMapping
-								.get(tmpProvided.getKey());
-
-						String[] providedSplits = providedFeatureName
-								.split(DELIMITER);
-
-						// not-connected ones are left over
-						if (providedSplits[0].isEmpty()) {
-							continue;
-						}
-
-						// found matching feature between TO and FROM
-						if (providedSplits[0].equals(currentVertex.getKey())
-								&& providedSplits[1].equals(requiredSplits[1])) {
-							otherVertexFeature = tmpProvided.getValue();
-						}
-					}
-
-					from = requiredSplits[0];
-
-					EdgeEfp edge = findEdgeInGraph(from, to);
-
-					// add new edge
-					if (edge == null) {
-						edge = new EdgeEfp(++id, from, to);
-						// from to
-						checkAddEdgeFeature(tmpRequired.getValue(),
-								otherVertexFeature, tmpRequired.getKey(), edge);
-
-						this.graph.addEdge(edge);
-					} else {
-						// add a feature to an old edge only
-						checkAddEdgeFeature(tmpRequired.getValue(),
-								otherVertexFeature, tmpRequired.getKey(), edge);
-					}
-				}
-
-			}
-		}
-
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * 
-	 * Find an existing edge in graph.
-	 * 
-	 * @param from
-	 *            Name of start vertex.
-	 * @param to
-	 *            name of end vertex.
-	 * @return Null if not found, edge otherwise.
-	 */
-	private EdgeEfp findEdgeInGraph(String from, String to) {
-		logger.trace("ENTRY");
-		List<EdgeInterface> tmpEdges = this.graph.getEdges();
-
-		for (EdgeInterface edge : tmpEdges) {
-			// found old edge
-			if (edge.getFrom().equals(from) && edge.getTo().equals(to)) {
-				logger.trace("EXIT");
-				return (EdgeEfp) edge;
-			}
-		}
-
-		logger.trace("EXIT");
-		return null;
-	}
-
-	/**
-	 * 
-	 * Check and add feature to edge.
-	 * 
-	 * @param requiredFeature
-	 *            Required feature with EFPs.
-	 * @param providedFeature
-	 *            Provided feature with EFPs.
-	 * @param name
-	 *            Feature name.
-	 * @param edge
-	 *            Edge where the feature belongs.
-	 */
-	private void checkAddEdgeFeature(CocaexDataFeature requiredFeature,
-			CocaexDataFeature providedFeature, String name, EdgeEfp edge) {
-		logger.trace("ENTRY");
-		EfpFeature tmpFeature = null;
-
-		// find out if the edge already has a features like the added one
-		for (EfpFeature oldFeature : edge.getFeatures()) {
-			// the edge contains the feature already
-			if (oldFeature.getName().equals(name)) {
-				tmpFeature = oldFeature;
-				break;
-			}
-		}
-
-		// an old feature
-		if (tmpFeature != null) {
-			tmpFeature = featureMap.get(name);
-
-			processEfpsToFeature(requiredFeature, providedFeature, tmpFeature,
-					edge);
-		} else { // add new feature to edge
-			tmpFeature = new EfpFeature(name);
-			
-			// preset the OK state
-			tmpFeature.setFeatureStatus(MatchingResult.OK.toString());
-
-			processEfpsToFeature(requiredFeature, providedFeature, tmpFeature,
-					edge);
-
-			edge.getFeatures().add(tmpFeature);
-			featureMap.put(name, tmpFeature);
-		}
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * 
-	 * Prepare process of adding EFP values to existing feature.
-	 * 
-	 * @param requiredFeature
-	 *            Required feature with EFPs.
-	 * @param providedFeature
-	 *            Provided feature with EFPs.
-	 * @param feature
-	 *            Existing feature.
-	 * @param edge
-	 *            Edge where the EFPs with feature belong.
-	 */
-	private void processEfpsToFeature(CocaexDataFeature requiredFeature,
-			CocaexDataFeature providedFeature, EfpFeature feature, EdgeEfp edge) {
-		logger.trace("ENTRY");
-
-		MatchingResult result = checkAddFeatureEfp(requiredFeature,
-				providedFeature, feature);
-
-		if (!result.equals(MatchingResult.OK)) {
-			edge.setEdgeStatusOk(false);
-			feature.setFeatureStatus(result.toString());
-		} 
-		
-		logger.trace("EXIT");
-	}
-
-	/**
-	 * 
-	 * Check and add EFPs to an existing feature.
-	 * 
-	 * @param requiredFeature
-	 *            Required feature with EFPs.
-	 * @param providedFeature
-	 *            Provided feature with EFPs.
-	 * @param feature
-	 *            Existing feature.
-	 * @return Result of EFPs comparison. OK/MISSING/ERROR
-	 */
-	private MatchingResult checkAddFeatureEfp(
-			CocaexDataFeature requiredFeature,
-			CocaexDataFeature providedFeature, EfpFeature feature) {
-		logger.trace("ENTRY");
-		final String defaultValue = "No value";
-
-		MatchingResult output = MatchingResult.OK;
-
-		// all EFPs bound to this feature
-		for (int i = 0; i < requiredFeature.getEfps().size(); i++) {
-			EfpComparison efpCmp = new EfpComparison();
-
-			CocaexDataEfp firstEfp = requiredFeature.getEfps().get(i);
-			CocaexDataEfp secondEfp = providedFeature.getEfps().get(i);
-
-			// set real values
-			if (firstEfp.getEfpValue() != null) {
-				efpCmp.setLeftEfpValue(firstEfp.getEfpValue().toString());
-			} else {
-				efpCmp.setLeftEfpValue(defaultValue);
-			}
-
-			if (secondEfp.getEfpValue() != null) {
-				efpCmp.setRightEfpValue(secondEfp.getEfpValue().toString());
-			} else {
-				efpCmp.setRightEfpValue(defaultValue);
-			}
-
-			efpCmp.setTypeName(firstEfp.getEfpValueTypeName());
-			efpCmp.setEfpName(firstEfp.getEfpName());
-			efpCmp.setComparisonStatus(firstEfp.getTypeError().name());
-
-			// at least one efp is not OK
-			if (!firstEfp.getTypeError().equals(MatchingResult.OK)) {
-				output = firstEfp.getTypeError();
-			}
-
-			feature.getEfps().add(efpCmp);
-		}
-		logger.trace("EXIT");
-
-		return output;
-	}
-}
+//package cz.zcu.kiv.offscreen.graph.creator;
+//
+//import java.util.ArrayList;
+//import java.util.HashMap;
+//import java.util.List;
+//import java.util.Map;
+//
+//import org.apache.log4j.Logger;
+//
+//import cz.zcu.kiv.efps.comparator.result.EfpEvalResult.MatchingResult;
+//import cz.zcu.kiv.offscreen.api.EdgeInterface;
+//import cz.zcu.kiv.offscreen.api.GraphInterface;
+//import cz.zcu.kiv.offscreen.api.VertexInterface;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexData;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexDataEfp;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexDataFeature;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
+//import cz.zcu.kiv.offscreen.graph.EdgeEfp;
+//import cz.zcu.kiv.offscreen.graph.GraphImpl;
+//import cz.zcu.kiv.offscreen.graph.VertexEfp;
+//import cz.zcu.kiv.offscreen.graph.efp.EfpComparison;
+//import cz.zcu.kiv.offscreen.graph.efp.EfpFeature;
+//
+///**
+// *
+// * Transforms data obtained in form of Map<String, CocaexData> to
+// * cz.zcu.kiv.offscreen.api.GraphInterface.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class EfpGraphTransfomer {
+//
+//	private final String DELIMITER = ";";
+//
+//	/**
+//	 * Output data format.
+//	 */
+//	private GraphInterface graph = null;
+//
+//	/**
+//	 * Input data format.
+//	 */
+//	private Map<String, CocaexData> resultData = null;
+//
+//	private Map<String, String> resultFeaturesMapping = null;
+//
+//	private Map<String, String> resultEfpsMapping = null;
+//
+//	/**
+//	 * Already used vertices.
+//	 */
+//	private Map<String, VertexInterface> vertexMap;
+//
+//	/**
+//	 * Already used features.
+//	 */
+//	private Map<String, EfpFeature> featureMap;
+//
+//	/**
+//	 * Logging.
+//	 */
+//	private Logger logger = Logger.getLogger(EfpGraphTransfomer.class);
+//
+//	/**
+//	 * New transformer from input data.
+//	 *
+//	 * @param efpportalResultsWrapper
+//	 *            Input data in from of EfpPortal app.
+//	 */
+//	public EfpGraphTransfomer(CocaexWrapper efpportalResultsWrapper) {
+//		logger.trace("ENTRY");
+//		this.graph = new GraphImpl();
+//
+//		this.resultData = efpportalResultsWrapper.getData();
+//		this.resultEfpsMapping = efpportalResultsWrapper.getEfpMappings();
+//		this.resultFeaturesMapping = efpportalResultsWrapper
+//				.getFeatureMappings();
+//
+//		this.vertexMap = new HashMap<String, VertexInterface>();
+//		this.featureMap = new HashMap<String, EfpFeature>();
+//
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 * Generates the graph with vertices and edges.
+//	 *
+//	 * @return graph
+//	 */
+//	public GraphInterface transform() {
+//		logger.trace("ENTRY");
+//		this.generateVertices();
+//		this.generateEdges();
+//
+//		// set proper feature and efp names
+//		this.setNamesInsteadOfNumbers();
+//		logger.trace("EXIT");
+//
+//		return this.graph;
+//	}
+//
+//	/**
+//	 * Substitute ID for the proper name string.
+//	 */
+//	private void setNamesInsteadOfNumbers() {
+//		logger.trace("ENTRY");
+//
+//		List<EdgeInterface> edges = graph.getEdges();
+//
+//		for (EdgeInterface edgeInterface : edges) {
+//			ArrayList<EfpFeature> features = ((EdgeEfp) edgeInterface)
+//					.getFeatures();
+//
+//			for (EfpFeature efpFeature : features) {
+//				// substitute ID for the true name from the feature mapping
+//				String tmpFeatureName = resultFeaturesMapping.get(efpFeature.getName());
+//
+//				efpFeature.setName(tmpFeatureName.split(DELIMITER)[1]);
+//
+//				ArrayList<EfpComparison> efps = efpFeature.getEfps();
+//
+//				for (EfpComparison efpComparison : efps) {
+//					// substitute ID for the true name from the efps mapping
+//					efpComparison.setEfpName(resultEfpsMapping
+//							.get(efpComparison.getEfpName()));
+//				}
+//			}
+//		}
+//
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 * Generate vertices for this graph.
+//	 */
+//	private void generateVertices() {
+//		logger.trace("ENTRY");
+//
+//		int id = 0;
+//		VertexEfp vertex;
+//
+//		for (Map.Entry<String, CocaexData> tmpData : resultData.entrySet()) {
+//			id++;
+//
+//			vertex = new VertexEfp(id, tmpData.getKey(), tmpData.getKey());
+//
+//			this.graph.addVertex(tmpData.getKey(), vertex);
+//			this.vertexMap.put(tmpData.getKey(), vertex);
+//		}
+//
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 * Generate edges for this graph.
+//	 */
+//	private void generateEdges() {
+//		logger.trace("ENTRY");
+//
+//		int id = 0;
+//		String from, to;
+//		CocaexData currentEvaluatedVertexData;
+//
+//		for (Map.Entry<String, VertexInterface> currentVertex : vertexMap
+//				.entrySet()) {
+//			currentEvaluatedVertexData = resultData.get(currentVertex.getKey());
+//
+//			to = currentVertex.getKey();
+//
+//			// all required features FROM
+//			for (Map.Entry<String, CocaexDataFeature> tmpRequired : currentEvaluatedVertexData
+//					.getRequiredFeatures().entrySet()) {
+//
+//				String requiredFeatureName = this.resultFeaturesMapping
+//						.get(tmpRequired.getKey());
+//
+//				// get feature name, its first part is component name
+//				String[] requiredSplits = requiredFeatureName.split(DELIMITER);
+//
+//				// not-connected ones are left over
+//				if (!requiredSplits[0].isEmpty()) {
+//
+//					// vertex from == vertex to -> we dont want that...
+//					if (requiredSplits[0].equals(currentVertex.getKey())) {
+//						continue;
+//					}
+//
+//					// find corresponding feature on the TO vertex
+//					CocaexData otherVertexData = resultData
+//							.get(requiredSplits[0]);
+//					CocaexDataFeature otherVertexFeature = null;
+//
+//					// go through all features of the TO
+//					for (Map.Entry<String, CocaexDataFeature> tmpProvided : otherVertexData
+//							.getProvidedFeatures().entrySet()) {
+//						String providedFeatureName = this.resultFeaturesMapping
+//								.get(tmpProvided.getKey());
+//
+//						String[] providedSplits = providedFeatureName
+//								.split(DELIMITER);
+//
+//						// not-connected ones are left over
+//						if (providedSplits[0].isEmpty()) {
+//							continue;
+//						}
+//
+//						// found matching feature between TO and FROM
+//						if (providedSplits[0].equals(currentVertex.getKey())
+//								&& providedSplits[1].equals(requiredSplits[1])) {
+//							otherVertexFeature = tmpProvided.getValue();
+//						}
+//					}
+//
+//					from = requiredSplits[0];
+//
+//					EdgeEfp edge = findEdgeInGraph(from, to);
+//
+//					// add new edge
+//					if (edge == null) {
+//						edge = new EdgeEfp(++id, from, to);
+//						// from to
+//						checkAddEdgeFeature(tmpRequired.getValue(),
+//								otherVertexFeature, tmpRequired.getKey(), edge);
+//
+//						this.graph.addEdge(edge);
+//					} else {
+//						// add a feature to an old edge only
+//						checkAddEdgeFeature(tmpRequired.getValue(),
+//								otherVertexFeature, tmpRequired.getKey(), edge);
+//					}
+//				}
+//
+//			}
+//		}
+//
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 *
+//	 * Find an existing edge in graph.
+//	 *
+//	 * @param from
+//	 *            Name of start vertex.
+//	 * @param to
+//	 *            name of end vertex.
+//	 * @return Null if not found, edge otherwise.
+//	 */
+//	private EdgeEfp findEdgeInGraph(String from, String to) {
+//		logger.trace("ENTRY");
+//		List<EdgeInterface> tmpEdges = this.graph.getEdges();
+//
+//		for (EdgeInterface edge : tmpEdges) {
+//			// found old edge
+//			if (edge.getFrom().equals(from) && edge.getTo().equals(to)) {
+//				logger.trace("EXIT");
+//				return (EdgeEfp) edge;
+//			}
+//		}
+//
+//		logger.trace("EXIT");
+//		return null;
+//	}
+//
+//	/**
+//	 *
+//	 * Check and add feature to edge.
+//	 *
+//	 * @param requiredFeature
+//	 *            Required feature with EFPs.
+//	 * @param providedFeature
+//	 *            Provided feature with EFPs.
+//	 * @param name
+//	 *            Feature name.
+//	 * @param edge
+//	 *            Edge where the feature belongs.
+//	 */
+//	private void checkAddEdgeFeature(CocaexDataFeature requiredFeature,
+//			CocaexDataFeature providedFeature, String name, EdgeEfp edge) {
+//		logger.trace("ENTRY");
+//		EfpFeature tmpFeature = null;
+//
+//		// find out if the edge already has a features like the added one
+//		for (EfpFeature oldFeature : edge.getFeatures()) {
+//			// the edge contains the feature already
+//			if (oldFeature.getName().equals(name)) {
+//				tmpFeature = oldFeature;
+//				break;
+//			}
+//		}
+//
+//		// an old feature
+//		if (tmpFeature != null) {
+//			tmpFeature = featureMap.get(name);
+//
+//			processEfpsToFeature(requiredFeature, providedFeature, tmpFeature,
+//					edge);
+//		} else { // add new feature to edge
+//			tmpFeature = new EfpFeature(name);
+//
+//			// preset the OK state
+//			tmpFeature.setFeatureStatus(MatchingResult.OK.toString());
+//
+//			processEfpsToFeature(requiredFeature, providedFeature, tmpFeature,
+//					edge);
+//
+//			edge.getFeatures().add(tmpFeature);
+//			featureMap.put(name, tmpFeature);
+//		}
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 *
+//	 * Prepare process of adding EFP values to existing feature.
+//	 *
+//	 * @param requiredFeature
+//	 *            Required feature with EFPs.
+//	 * @param providedFeature
+//	 *            Provided feature with EFPs.
+//	 * @param feature
+//	 *            Existing feature.
+//	 * @param edge
+//	 *            Edge where the EFPs with feature belong.
+//	 */
+//	private void processEfpsToFeature(CocaexDataFeature requiredFeature,
+//			CocaexDataFeature providedFeature, EfpFeature feature, EdgeEfp edge) {
+//		logger.trace("ENTRY");
+//
+//		MatchingResult result = checkAddFeatureEfp(requiredFeature,
+//				providedFeature, feature);
+//
+//		if (!result.equals(MatchingResult.OK)) {
+//			edge.setEdgeStatusOk(false);
+//			feature.setFeatureStatus(result.toString());
+//		}
+//
+//		logger.trace("EXIT");
+//	}
+//
+//	/**
+//	 *
+//	 * Check and add EFPs to an existing feature.
+//	 *
+//	 * @param requiredFeature
+//	 *            Required feature with EFPs.
+//	 * @param providedFeature
+//	 *            Provided feature with EFPs.
+//	 * @param feature
+//	 *            Existing feature.
+//	 * @return Result of EFPs comparison. OK/MISSING/ERROR
+//	 */
+//	private MatchingResult checkAddFeatureEfp(
+//			CocaexDataFeature requiredFeature,
+//			CocaexDataFeature providedFeature, EfpFeature feature) {
+//		logger.trace("ENTRY");
+//		final String defaultValue = "No value";
+//
+//		MatchingResult output = MatchingResult.OK;
+//
+//		// all EFPs bound to this feature
+//		for (int i = 0; i < requiredFeature.getEfps().size(); i++) {
+//			EfpComparison efpCmp = new EfpComparison();
+//
+//			CocaexDataEfp firstEfp = requiredFeature.getEfps().get(i);
+//			CocaexDataEfp secondEfp = providedFeature.getEfps().get(i);
+//
+//			// set real values
+//			if (firstEfp.getEfpValue() != null) {
+//				efpCmp.setLeftEfpValue(firstEfp.getEfpValue().toString());
+//			} else {
+//				efpCmp.setLeftEfpValue(defaultValue);
+//			}
+//
+//			if (secondEfp.getEfpValue() != null) {
+//				efpCmp.setRightEfpValue(secondEfp.getEfpValue().toString());
+//			} else {
+//				efpCmp.setRightEfpValue(defaultValue);
+//			}
+//
+//			efpCmp.setTypeName(firstEfp.getEfpValueTypeName());
+//			efpCmp.setEfpName(firstEfp.getEfpName());
+//			efpCmp.setComparisonStatus(firstEfp.getTypeError().name());
+//
+//			// at least one efp is not OK
+//			if (!firstEfp.getTypeError().equals(MatchingResult.OK)) {
+//				output = firstEfp.getTypeError();
+//			}
+//
+//			feature.getEfps().add(efpCmp);
+//		}
+//		logger.trace("EXIT");
+//
+//		return output;
+//	}
+//}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/AttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/AttributeFilter.java
new file mode 100644
index 0000000..7dcda7b
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/AttributeFilter.java
@@ -0,0 +1,43 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.util.HashMap;
+
+public class AttributeFilter {
+    private HashMap<Integer, NumberAttributeFilter> numberFilters = new HashMap<Integer, NumberAttributeFilter>();
+    private HashMap<Integer, EnumAttributeFilter> enumFilters = new HashMap<Integer, EnumAttributeFilter>();
+    private HashMap<Integer, DateAttributeFilter> dateFilters = new HashMap<Integer, DateAttributeFilter>();
+    private HashMap<Integer, StringAttributeFilter> stringFilters = new HashMap<Integer, StringAttributeFilter>();
+
+
+    public void addNumberFilter(int attrTypeIndex, NumberAttributeFilter filter) {
+        numberFilters.put(attrTypeIndex, filter);
+    }
+
+    public NumberAttributeFilter getNumberFilter(int attrTypeIndex) {
+        return numberFilters.get(attrTypeIndex);
+    }
+
+    public void addEnumFilter(int attrTypeIndex, EnumAttributeFilter filter) {
+        enumFilters.put(attrTypeIndex, filter);
+    }
+
+    public EnumAttributeFilter getEnumFilter(int attrTypeIndex) {
+        return enumFilters.get(attrTypeIndex);
+    }
+
+    public void addDateFilter(int attrTypeIndex, DateAttributeFilter filter) {
+        dateFilters.put(attrTypeIndex, filter);
+    }
+
+    public DateAttributeFilter getDateFilter(int attrTypeIndex) {
+        return dateFilters.get(attrTypeIndex);
+    }
+
+    public void addStringFilter(int attrTypeIndex, StringAttributeFilter filter) {
+        stringFilters.put(attrTypeIndex, filter);
+    }
+
+    public StringAttributeFilter getStringFilter(int attrTypeIndex) {
+        return stringFilters.get(attrTypeIndex);
+    }
+}
